#include "Text_Message_Pad.h"

/// _______                                           ______           __
///|   |   |.-----.-----.-----.---.-.-----.-----.    |   __ \.---.-.--|  |
///|       ||  -__|__ --|__ --|  _  |  _  |  -__|    |    __/|  _  |  _  |
///|__|_|__||_____|_____|_____|___._|___  |_____|    |___|   |___._|_____|
///                                 |_____|
/// First attempt at my own class... so don't be too critical...

/// There is almost definetly an issues with the Message Vector causing SEG Faults....

Text_Message_Pad::Text_Message_Pad(TGGroupFrame *p, int w, int h): TGCompositeFrame(p, w, h)//, UInt_t options)
{
    Mess_Pad_x=w;
    Mess_Pad_y=h;
    SetCleanup(kDeepCleanup);
    /// Set variables
    Set_Mess_Pad_Var();

    /// Group frame
    Mess_Pad_Frame = new TGGroupFrame(p, "Messages",kVerticalFrame);
    Mess_Pad_Frame->SetTitlePos(TGGroupFrame::kCenter);
    p->AddFrame(Mess_Pad_Frame, new TGLayoutHints(kLHintsCenterX|kLHintsExpandX,0,0,0,0));

    /// Embedded canvas
    Mess_Pad_eCanvas = new TRootEmbeddedCanvas("Ecanvas",Mess_Pad_Frame, Mess_Pad_x, Mess_Pad_y);
    Mess_Pad_Canvas = Mess_Pad_eCanvas->GetCanvas();
    Mess_Pad_Frame->AddFrame( Mess_Pad_eCanvas, new TGLayoutHints(kLHintsCenterX|kLHintsExpandX,0,0,0,0) );

    /// Pave text for the messages
    Mess_Pad_Pave_Text = new TPaveText(0.0,0.0,1.0,1.0,"NDC"); // leave a bit of space to stop text going out of frame
    Mess_Pad_Pave_Text->SetBorderSize(0);
    Mess_Pad_Pave_Text->SetFillColor(0);

    /// Some inital messages to get things going
    std::string Mess_Box_Startup_Text="Welcome to the Scope Config Window and a load of other text. In the future, hopefully, I will find a way to better split longer messages accross more than one line but at the moment word wrapping is trickier than you might think.";
    Update_Message_Vector(Mess_Box_Startup_Text);
    Mess_Box_Startup_Text="Messages will be displayed here.";
    Update_Message_Vector(Mess_Box_Startup_Text);
    Update_Message_Canvas();
}

Text_Message_Pad::Text_Message_Pad(TGVerticalFrame *p, int w, int h): TGCompositeFrame(p, w, h)//, UInt_t options)
{
    Mess_Pad_x=w;
    Mess_Pad_y=h;
    SetCleanup(kDeepCleanup);
    /// Set variables
    Set_Mess_Pad_Var();

    /// Group frame
    Mess_Pad_Frame = new TGGroupFrame(p, "Messages",kVerticalFrame);
    Mess_Pad_Frame->SetTitlePos(TGGroupFrame::kCenter);
    p->AddFrame(Mess_Pad_Frame, new TGLayoutHints(kLHintsCenterX|kLHintsExpandX,0,0,0,0));

    /// Embedded canvas
    Mess_Pad_eCanvas = new TRootEmbeddedCanvas("Ecanvas",Mess_Pad_Frame, Mess_Pad_x, Mess_Pad_y);
    Mess_Pad_Canvas = Mess_Pad_eCanvas->GetCanvas();
    Mess_Pad_Frame->AddFrame( Mess_Pad_eCanvas, new TGLayoutHints(kLHintsCenterX|kLHintsExpandX,0,0,0,0) );

    /// Pave text for the messages
    Mess_Pad_Pave_Text = new TPaveText(0.0,0.0,1.0,1.0,"NDC"); // leave a bit of space to stop text going out of frame
    Mess_Pad_Pave_Text->SetBorderSize(0);
    Mess_Pad_Pave_Text->SetFillColor(0);

    /// Some inital messages to get things going
    std::string Mess_Box_Startup_Text="Welcome to the Scope Config Window and a load of other text. In the future, hopefully, I will find a way to better split longer messages accross more than one line but at the moment word wrapping is trickier than you might think.";
    Update_Message_Vector(Mess_Box_Startup_Text);
    Mess_Box_Startup_Text="Messages will be displayed here.";
    Update_Message_Vector(Mess_Box_Startup_Text);
    Update_Message_Canvas();
}
/// The destructor, assume everything gets cleared up ok... ?
Text_Message_Pad::~Text_Message_Pad()
{
    //Delete all widgets. TGTransientFrame should handle it.
    delete Message_Vector;
    delete this;
}

/// Set Variables
void Text_Message_Pad::Set_Mess_Pad_Var()
{

    Num_Messages             = 0;
    Last_Message_Pos         = 0;
    Num_Char_Per_Line        = (int)floor((float)Mess_Pad_x / 6.5f );
    Max_Lines_In_Message_Box = (int)floor((float)Mess_Pad_y / 14.0f)-1;
    Max_Messages_In_Buffer   = Max_Lines_In_Message_Box+500;
    Message_Vector = new std::vector<std::string>(Max_Messages_In_Buffer);
}
/// UPDATE THE VECTOR (BUFFER) WITH A NEW MESSAGE
void Text_Message_Pad::Update_Message_Vector(std::string newmessage)
{
    newmessage.insert(0,">> ");     /// Prepend a start of message prefix.
    temp_int1=newmessage.size();    /// where to cut long messages.....
    temp_int2=(int)floor( (float)temp_int1 / (float)Num_Char_Per_Line);
    temp_int3=temp_int1 % Num_Char_Per_Line;
    for(i=0;i<temp_int2+1;++i)
    {
        if((i+1)*Num_Char_Per_Line>temp_int1)    ///Check to see if we're at the end of the message
        {
            (*Message_Vector)[Last_Message_Pos]=newmessage.substr(i*Num_Char_Per_Line,temp_int3);
        }
        else
        {
            (*Message_Vector)[Last_Message_Pos]=newmessage.substr(i*Num_Char_Per_Line,Num_Char_Per_Line);
        }
        Num_Messages+=1;    /// Update counters
        Last_Message_Pos+=1;
        if(Last_Message_Pos>Max_Messages_In_Buffer-1)   /// Reset to 0 once above Max_Messages_In_Buffer
        {
            Last_Message_Pos=0;
        }
    }

}
/// Write the message to the embedded canvas
void Text_Message_Pad::Update_Message_Canvas()
{
    Mess_Pad_Pave_Text->Clear();
    if(Num_Messages<Max_Lines_In_Message_Box)
    {
        for(i=0;i<Num_Messages;++i)
        {
            Gen::Add_To_PaveText(Mess_Pad_Pave_Text,(*Message_Vector)[i],align_xLyC,black,43,14);
            temp_int1 = i;
        }
        while(temp_int1<Max_Lines_In_Message_Box)
        {
            Gen::Add_To_PaveText(Mess_Pad_Pave_Text,">>",align_xLyC,black,43,14);
            ++temp_int1;
        }
    }else{

        for(i=Max_Lines_In_Message_Box;i>0;--i)
        {
            temp_int1=Last_Message_Pos-i;
            if(temp_int1<0)
            {
                Gen::Add_To_PaveText(Mess_Pad_Pave_Text,(*Message_Vector)[temp_int1+Max_Messages_In_Buffer],align_xLyC,black,43,14);
            }else{
                Gen::Add_To_PaveText(Mess_Pad_Pave_Text,(*Message_Vector)[temp_int1],align_xLyC,black,43,14);
            }
        }
    }
    Mess_Pad_Canvas->cd();
    Mess_Pad_Pave_Text->Draw();
    Mess_Pad_Canvas->Update();
}
/// Functions to add and display message, overloaded for strings, char arrays, int, SHOULD INCLUDE MORE OF THESE....???? is this the way to do it?
void Text_Message_Pad::AddMessage(char message[])
{
        std::string stringmessage(message);
        Update_Message_Vector(stringmessage.c_str());
        Update_Message_Canvas();
}

void Text_Message_Pad::AddMessage(std::string message)
{
        Update_Message_Vector(message.c_str());
        Update_Message_Canvas();
}

void Text_Message_Pad::AddMessage(int val)
{
        Update_Message_Vector(static_cast<std::ostringstream*>( &(std::ostringstream() << val) )->str());
        Update_Message_Canvas();
}

void Text_Message_Pad::AddMessage(float val)
{
        Update_Message_Vector(static_cast<std::ostringstream*>( &(std::ostringstream() << val) )->str());
        Update_Message_Canvas();
}

void Text_Message_Pad::AddMessage(long val)
{
        Update_Message_Vector(static_cast<std::ostringstream*>( &(std::ostringstream() << val) )->str());
        Update_Message_Canvas();
}

void Text_Message_Pad::AddMessage(Double_t val)
{
        Update_Message_Vector(static_cast<std::ostringstream*>( &(std::ostringstream() << val) )->str());
        Update_Message_Canvas();
}

/// Append Message Vector with passed variable
void Text_Message_Pad::Append_Last_Message(std::string newmessage)
{
    newmessage.insert(0," "); ///add a space to the beginning of the text to append
    (*Message_Vector)[Last_Message_Pos-1]=(*Message_Vector)[Last_Message_Pos-1]+newmessage;
}

void Text_Message_Pad::AppendMessage(std::string message)
{
        Append_Last_Message(message.c_str());
        Update_Message_Canvas();
}

void Text_Message_Pad::AppendMessage(int val)
{
        Append_Last_Message(static_cast<std::ostringstream*>( &(std::ostringstream() << val) )->str());
        Update_Message_Canvas();
}

void Text_Message_Pad::AppendMessage(float val)
{
       Append_Last_Message(static_cast<std::ostringstream*>( &(std::ostringstream() << val) )->str());
       Update_Message_Canvas();
}

void Text_Message_Pad::AppendMessage(Double_t val)
{
       Append_Last_Message(static_cast<std::ostringstream*>( &(std::ostringstream() << val) )->str());
       Update_Message_Canvas();
}


