#ifndef _Text_Message_Pad_H
#define _Text_Message_Pad_H

#include <TRootEmbeddedCanvas.h>
#include <TGButtonGroup.h>
#include <TGNumberEntry.h>
#include <TPaveText.h>
#include <TG3DLine.h>
#include <TGButton.h>
#include <TGFrame.h>
#include <TCanvas.h>
#include <TGLabel.h>
#include <TGTable.h>

#include <iostream>
#include <sstream>
#include <string>
#include <vector>

#include "DJS_General_Functions.h"

class Text_Message_Pad: public TGCompositeFrame //public TGTransientFrame /// inherits from this class.
{
    private:

        int temp_int1,temp_int2,temp_int3,i,j,k;
        float temp_float;

        /// ENUMS for Root Text Options
        enum Root_Col_t { black = 0, yellow = 5, cyan = 7, red = 2, offwhite = 10, magenta = 6 };
        enum Root_Align_t { align_xLyC=12,align_xCyC=22,align_xRyC=32};
        /// General layout hints
        TGLayoutHints   *HintsLeft_0,*HintsLeft_1,*HintsLeft_2,*HintsExpandX_0,*HintsExpandX_1,*HintsExpandX_2,*HintsRight_0,*HintsRight_1,*HintsRight_2,*HintsLeftExpX_2,*HintsLeftExpX_1,*HintsLeftExpX_0,*HintsLeftExpandX_0,*HintsLeftExpandX_1,*HintsLeftExpandX_2,*HintsLeftExpandXY_0,*HintsLeftExpandXY_1,*HintsLeftExpandXY_2, *HintsLeftExpandY_0,*HintsLeftExpandY_1,*HintsLeftExpandY_2,*HintsCenterX_0,*HintsCenterX_1,*HintsCenterX_2;

        TGCompositeFrame * Window_Frame;
        TGGroupFrame *Mess_Pad_f;
        TRootEmbeddedCanvas *Mess_Pad_eCan;

        /// Message Pad
        /// Message pad objects
        TGGroupFrame             *Mess_Pad_Frame;
        TRootEmbeddedCanvas      *Mess_Pad_eCanvas;
        TCanvas                  *Mess_Pad_Canvas;
        TPaveText                *Mess_Pad_Pave_Text;
        std::vector<std::string> *Message_Vector;
        //std::vector<int>        *Messages_Num_Lines;


        TPaveText *Message_Pave_Text;
        int Mess_Pad_y,Mess_Pad_x;

        int Max_Messages_In_Buffer,Num_Messages,Last_Message_Pos,Num_Char_Per_Line,Max_Lines_In_Message_Box;

       // int num_char_per_line;            /// not really sure if this is a good way to do this.... ?
        int num_messages;
        int Total_Num_Message_Lines;

        int Num_Lines_In_Message_Box;

    public:
        //Text_Message_Pad(const TGWindow *p, const TGWindow *main, UInt_t h, UInt_t w, UInt_t options=kVerticalFrame);
        Text_Message_Pad(TGGroupFrame *p, int w, int h);
        Text_Message_Pad(TGVerticalFrame *p, int w, int h);
        virtual ~Text_Message_Pad();

        //void UpdateMessageBox();
        //void UpdateMessageVector(std::string newmessage);
        //void WriteMessage(std::string message);

        //void WriteMessageInt(int val);

        void Set_Mess_Pad_Var();

        /// Message pad functions
        void Update_Message_Vector(std::string newmessage);
        void Update_Message_Canvas();
        void Append_Last_Message(std::string newmessage);

        void AddMessage(char message[]);

        void AddMessage(std::string message);
        void AddMessage(int val);
        void AddMessage(float val);
        void AddMessage(Double_t val);
        void AddMessage(long val);

        void AppendMessage(Double_t val);
        void AppendMessage(std::string message);
        void AppendMessage(int val);
        void AppendMessage(float val);


    ClassDef(Text_Message_Pad,0);
};

#endif


