#ifndef _EMBEDDEDINFOCANVAS_H
#define _EMBEDDEDINFOCANVAS_H

//Root includes
#include <TRootEmbeddedCanvas.h>
#include <TPaveText.h>
#include <TStyle.h>
#include <TCanvas.h>
#include <TPad.h>

//stdlib includes
#include <iostream>
#include <fstream>
#include <vector>

//NJE includes
#include "Global_Values_Extern.h"
#include "TomographyStructs.h"
//#include "TomographyStructDefaults.h"

class embeddedInfoCanvas
{
	private:
		TRootEmbeddedCanvas *canvas;
		TPad *mainPad;
		TPaveText *info;
		void setup();

	public:
		embeddedInfoCanvas(const char* name = 0, const TGWindow* p = 0, UInt_t w = 10, UInt_t h = 10, UInt_t options = kRaisedFrame|kDoubleBorder);
		~embeddedInfoCanvas();
		void setText(const char* text);
		void Draw();
		void Update();
		void Paint();
		TPad* GetMain();
		TCanvas* GetTCanvas();
		TRootEmbeddedCanvas* GetEmbedded();

	ClassDef(embeddedInfoCanvas, 0)
};

#endif


