
#include "formatConfig.h" //Class Header

#include "Global_Values_Extern.h"

int formatConfig::count = 0;

//Begin FormatConfigWindow_______________________________________
formatConfig::formatConfig(const TGWindow *p, UInt_t w, UInt_t h, masterController* mc, UInt_t options): TGMainFrame(p, w, h, options)
{
  formatConfig::count++;
  master = mc;
  SetCleanup(kDeepCleanup);

  Connect( "CloseWindow()", "formatConfig", this, "closeWindow()" );
  DontCallClose();

  //Frames ________________________________________________________________

  TGCompositeFrame *colorCompFrame  = new TGCompositeFrame( this, 350, 20, kVerticalFrame );
  TGCompositeFrame *buttonCompFrame = new TGCompositeFrame( this, 350, 10, kHorizontalFrame | kLHintsExpandX);
  
  TGGroupFrame *Grp_Colors = new TGGroupFrame( colorCompFrame, new TGString("Color Schemes"), kVerticalFrame | kRaisedFrame );
  
  //Widgets_______________________________________________________________
  
  ColorOptions[0] = new TGRadioButton( Grp_Colors, new TGHotString("Ice              "), 0 );
  ColorOptions[1] = new TGRadioButton( Grp_Colors, new TGHotString("Fire             "), 1 );
  ColorOptions[2] = new TGRadioButton( Grp_Colors, new TGHotString("Earth            "), 2 );
  ColorOptions[3] = new TGRadioButton( Grp_Colors, new TGHotString("Grab yer Ray-Bans"), 3 );
  ColorOptions[4] = new TGRadioButton( Grp_Colors, new TGHotString("Rainbow          "), 4 );
  ColorOptions[5] = new TGRadioButton( Grp_Colors, new TGHotString("Hellfire         "), 5 );
  ColorOptions[6] = new TGRadioButton( Grp_Colors, new TGHotString("Neon Midnight    "), 6 );
  ColorOptions[7] = new TGRadioButton( Grp_Colors, new TGHotString("Grayscale        "), 7 );
  ColorOptions[8] = new TGRadioButton( Grp_Colors, new TGHotString("BlueGreenYellow  "), 8 );
   
  TGTextButton *bSetFC  = new TGTextButton( buttonCompFrame, "Set Config." , -1 );
  bSetFC->Connect( "Clicked()", "formatConfig", this, "SetFormat()" );
    
  //Add Frames___________________________________________________________
  TGLayoutHints *Radio_Hints = new TGLayoutHints( kLHintsTop | kLHintsLeft, 5, 5, 5, 5);

  for(int i = 0; i < 9; ++i)
  {
    Grp_Colors->AddFrame( ColorOptions[i], Radio_Hints );
    ColorOptions[i]->Associate(this);
  } 

  ColorOptions[Current_Format.scheme_ID]->SetState(kButtonDown);

  colorCompFrame ->AddFrame(Grp_Colors, new TGLayoutHints( kLHintsCenterX | kLHintsCenterY, 2, 2, 2, 2 ));
  buttonCompFrame->AddFrame(bSetFC    , new TGLayoutHints( kLHintsCenterX | kLHintsCenterY, 2, 2, 2, 2 ));
  AddFrame(colorCompFrame , new TGLayoutHints( kLHintsExpandX | kLHintsTop    , 2, 2, 2, 2 ));
  AddFrame(buttonCompFrame, new TGLayoutHints( kLHintsExpandX | kLHintsBottom , 2, 2, 2, 2 ));

  //Map Window
  SetWindowName( "Formatting Configuration" );
  MapSubwindows();
  Layout();
  Resize( 300, 350 );
  MapWindow();

  TQObject::Connect("formatConfig", "raise()","formatConfig()",this, "wantsFocus()");
  
}

formatConfig::~formatConfig()
{

}

void formatConfig::closeWindow()
{
  formatConfig::count--;
  delete this;
}

Bool_t formatConfig::ProcessMessage(Long_t msg, Long_t param1, Long_t)
{
  switch(GET_SUBMSG(msg)){
    case kCM_RADIOBUTTON:
    {
      for(int i = 0; i < 9; ++i)
      {
        ColorOptions[i]->SetState( kButtonUp );
        if( i == param1 ) ColorOptions[i]->SetState(kButtonDown);
      }
    }
    break;

    default:
    break;
  }
  return kTRUE;
}

void formatConfig::SetFormat()
{
  int whichButton = 0;

  for(int i = 0; i < 9; ++i) if( ColorOptions[i]->GetState() == kButtonDown ) whichButton = i;

  //Make const Format_Configs for each of these. 
  setGlobalPalette(whichButton);
  Current_Format.scheme_ID = whichButton;
  master->updateAll();
}
