#ifndef _FORMATCONFIG_H
#define _FORMATCONFIG_H

#include <TGNumberEntry.h>
#include <TGStatusBar.h>
#include <TGFrame.h>
#include <TCanvas.h>
#include <stdlib.h>
#include <vector>
#include <TH1.h>
#include <map>
#include "TomographyStructs.h"
//#include "TomographyStructDefaults.h"
#include "masterController.h"

class masterController;
class TRootEmbeddedCanvas;
class TGTransientFrame;
class TGNumberEntry;
class TGCheckButton;
class TGMainFrame;
class TGStatusBar;
class TGComboBox;
class TGWindow;
class TGLabel;
class TGTab;
class TH2F;

class formatConfig: public TGMainFrame
{

  private:
    static int count;

    masterController* master;

    TGRadioButton *ColorOptions[9];
    TGRadioButton *ReconOptions[2];

    enum RadioSelections
    {
        kRadio_Color_Ice,
        kRadio_Color_Fire,
        kRadio_Color_Earth,
        kRadio_Color_Oil
    };

  public:
    
    formatConfig(const TGWindow *p, UInt_t h, UInt_t w, masterController* mc, UInt_t options = kVerticalFrame);
    ~formatConfig();
    void closeWindow();

    void SetFormat();
    Bool_t ProcessMessage(Long_t msg, Long_t param1, Long_t);

    static int getCount(){ return formatConfig::count; };

    void raise(){ Emit("raise()"); };
    void wantsFocus(){ this->RequestFocus(); this->RaiseWindow(); };

    ClassDef(formatConfig, 0)    
};

#endif
