#ifndef _FULLCONFIG_H
#define _FULLCONFIG_H

#include <TGNumberEntry.h>
#include <TGStatusBar.h>
#include <TGComboBox.h>
#include <TGFrame.h>
#include <vector>
#include <TH1.h>
#include <map>
#include "TomographyStructs.h"
//#include "TomographyStructDefaults.h"

#include "masterController.h"

class masterController;

class fullConfig: public TGMainFrame
{

	private:

		static int count;
		//controller
		masterController* master; 

		TGTextButton *mSet, *mSave, *mLoad;
		TGTextButton *tSet, *tSave, *tLoad;
		TGComboBox   *algorithmSelector;

		std::vector< TGNumberEntry* > machineBoxes;
    	std::vector< TGNumberEntry* > tomographyBoxes;

    	Machine_Config    localMachine; 
    	Tomography_Config localTomography;

		void addMachineFrame();
		void addTomographyFrame();

	public:
		fullConfig(const TGWindow *p, UInt_t h, UInt_t w, masterController* master, UInt_t options = kVerticalFrame);
		virtual ~fullConfig();
		void CloseWindow();

		//Retrieve values
		void setTomography();
		void setTomographyThenEmit(int button);
		void setMachine();
		void setMachineThenEmit(int button);
		
		Tomography_Config getTomography();
		Machine_Config    getMachine();

		static int getCount(){ return fullConfig::count; };

		//Signals
		void emitButton(int which){ EmitVA("emitButton(int)", 1 , which ); };
		enum buttonSignals
		{
			//machine config signals
			kButton_mSet,
			kButton_mSave,
			kButton_mLoad,
			kButton_mApply,
			kButton_mMakeDefault,
			//tomography config signals
			kButton_tSet,
			kButton_tSave,
			kButton_tLoad,
			kButton_tApply,
			kButton_tMakeDefault	
		};

		ClassDef(fullConfig, 0);
};

#endif

