#include "historyWindow.h"

bool historyWindow::exists = false;

historyWindow::historyWindow(const TGWindow* p, int w, int h, masterController* mc, int options) : TGMainFrame(p, w, h, options)
{
	if( historyWindow::exists )
	{
		raise();
	}else{
		historyWindow::exists = true;
		master = mc;
		SetCleanup(kDeepCleanup);

	  	Connect("CloseWindow()", "historyWindow", this, "CloseWindow()");
	  	DontCallClose();

	  	fMenuBar = new TGMenuBar(this, 100, 20, kHorizontalFrame);
		TGLayoutHints *fMenuPopupLayout = new TGLayoutHints(kLHintsTop | kLHintsLeft );

		TGPopupMenu *fMenu_File  = new TGPopupMenu( gClient->GetDefaultRoot() );
		TGPopupMenu *fMenu_Opts  = new TGPopupMenu( gClient->GetDefaultRoot() );

		fMenu_File->AddEntry("Save Canvas As Image", kMenu_File_Save_Canvas_PDF );

		fMenu_Opts->AddEntry("Recon Only"         , kMenu_Opts_Recon           );
		fMenu_Opts->AddEntry("Recon + Data"       , kMenu_Opts_Recon_Data      );
		fMenu_Opts->AddEntry("Recon + Prof + Data", kMenu_Opts_Recon_Prof_Data );
		//fMenu_Opts->CheckEntry(Menu_Opts_Recon);

		fMenuBar->AddPopup("File"   , fMenu_File , fMenuPopupLayout );
		fMenuBar->AddPopup("Options", fMenu_Opts , fMenuPopupLayout );
		// fMenu_Opts->CheckEntry(whatToPlot); //Default value is checked. 
		AddFrame(fMenuBar, new TGLayoutHints(kLHintsTop | kLHintsCenterX | kLHintsExpandX, 1, 1, 0, 0));

		fMenu_Opts->Connect("Activated(Int_t)", "masterController", master, "multiBunchSignal(Int_t)");
		fMenu_File->Connect("Activated(Int_t)", "masterController", master, "multiBunchSignal(Int_t)");

		TGHorizontal3DLine *MenuSep = new TGHorizontal3DLine(this); 
		AddFrame( MenuSep, new TGLayoutHints(kLHintsTop | kLHintsExpandX ) );

		TGHorizontalFrame *fr1 = new TGHorizontalFrame( this, 1200, 600 );
		AddFrame( fr1, new TGLayoutHints( kLHintsExpandX | kLHintsExpandY, 0,0,1,0) );

		canvas = new embeddedInfoCanvas("histCanvas", fr1, 970,600);
		fr1->AddFrame(canvas->GetEmbedded(), new TGLayoutHints(kLHintsExpandX | kLHintsExpandY , 0,0,1,0) );

		//Map Window
	  	SetWindowName("History Plots");

	  	// master->Connect( "historyWindow" ,"raiseHistory()", "historyWindow", this, "wantsFocus()" );
	  	Connect( "historyWindow" ,"raise()", "historyWindow", this, "wantsFocus()" );
	  	MapSubwindows();
	  	Resize();
	  	MapWindow(); 
  	}
}

historyWindow::~historyWindow()
{
	;
}

void historyWindow::CloseWindow()
{
	historyWindow::exists = false;
	delete this;
}

