#ifndef _MAINWINDOW_H
#define _MAINWINDOW_H
//Check mode and make sure not in CINT.
#ifndef _OFFLINE_MODE
#ifndef __CINT__
#include "ACNETIncludes.h"
#endif
#endif
//Root headers
#include <TRootEmbeddedCanvas.h>
#include <TGNumberEntry.h>
#include <TGProgressBar.h>
#include <TGStatusBar.h>
#include <TGPicture.h>
#include <TSystem.h>
#include <TGLabel.h>
#include <TGFrame.h>
#include <TCanvas.h>
#include <TTimer.h>
#include <TGMenu.h>
#include <TGTab.h>
#include <TH1.h>
//c headers
#include <vector>
//NJE Headers
#include "TomographyStructs.h"
//#include "TomographyStructDefaults.h"
#include "Global_Values_Extern.h" 

#include "masterController.h"
#include "tabbedInfoWindow.h"

class tabbedInfoWindow;
class masterController;

class mainWindow: public tabbedInfoWindow 
{
  private:

    static int count;

    //Widgets
    TGHProgressBar *progress;
    TGTextButton   *bGetScope;
    TGTextButton   *bLoop;
    TGStatusBar    *fStatus;
    TGMenuBar      *fMenuBar;
    TGTab          *InjTab;

    int whichAlgorithm;
    int inputType;
      
  public:

    enum windowSignals
    {
      kButton_Mlti,
      kButton_Tomo,
      kButton_getScope,
      kButton_Loop,
      kButton_Hist,
      kButton_ScopeSingle,

      kMenu_File_Open_PRP,
      kMenu_File_Open_RAW,
      kMenu_File_Open_Ming_Jen,
      kMenu_File_Save_Raw_Data,
      kMenu_File_Save_Recon,
      kMenu_File_Save_Recon_Prof,
      kMenu_File_Save_Canvas_PDF,

      kMenu_Config_Scope,
      kMenu_Config_Recon,
      kMenu_Config_Format,
      kMenu_Config_PlotLayout,

      kMenu_Input_Preprocessed,
      kMenu_Input_MingJen,

      kMenu_Algo_FCART, 
      kMenu_Algo_DFCART,
      kMenu_Algo_FCART2    
    };

    mainWindow( const TGWindow *p, int numberOfTabs, UInt_t w = 0, UInt_t h = 0 );
    virtual ~mainWindow();
    void closeWindow();

    void emitPad( int tab, TVirtualPad* pad ){ EmitVA( "emitPad(int,TVirtualPad*)", 2, tab, pad ); };
    void emitSignal( int signalInt ){ EmitVA( "emitSignal(Int_t)", 1, signalInt ); };

    int getAlgorithm()
    { 
      return whichAlgorithm; 
    };

    void setStatus( const char* status, const int part = 0 );
    void setProgressStatus(const char* status);
    void setProgress(const int percent);
    void setLoopButton( bool looping );
    void setScopeButton( bool hasScope );

  ClassDef(mainWindow,0)    
};

#endif
