#ifndef _PLOTLAYOUTWINDOW_H
#define _PLOTLAYOUTWINDOW_H
//Root headers
#include <TRootEmbeddedCanvas.h>
#include <TGNumberEntry.h>
#include <TGStatusBar.h>
#include <TGComboBox.h>
#include <TGLabel.h>
#include <TGFrame.h>
#include <TCanvas.h>
#include <TPad.h>
#include <TH1.h>
//c headers
#include <vector>
//NJE headers
#include "TomographyStructs.h"
//#include "TomographyStructDefaults.h"
#include "mainView.h"
#include "masterController.h"

class TRootEmbeddedCanvas;
class TGNumberEntry;
class TGMainFrame;
class TCanvas;
class TGLabel;
class TGTab;
class TPad;
class TH2F;
class mainView;
class masterController;

class plotLayoutWindow: public TGMainFrame
{
    
 private:

  static int count;

  masterController* master;

  std::vector< TGNumberEntry* > PadNumberEntry;
  std::vector< TGComboBox*    > PlotSelectors;
  std::vector< TGNumberEntry* > minRangeSelectors;
  std::vector< TGNumberEntry* > maxRangeSelectors;

  std::vector< TPad* > DummyPads;

  std::vector< int > ColumnsPerRow; 

  TRootEmbeddedCanvas* PreviewPane;
  TCanvas*             MainCanvas;

  std::vector< plotFormat > *formatToModify;
  std::vector< plotFormat > thisFormat;
  mainView*                 thisView;

  void createSideBar();   
  void createPreviewPane();

 public:

  plotLayoutWindow( const TGWindow *p, UInt_t h, UInt_t w, masterController* mc, std::vector<plotFormat> *pf, UInt_t options=kHorizontalFrame );
  virtual ~plotLayoutWindow();

  void closeWindow();
 
  void applyFormat();
  void previewFormat();
  void restoreDefault();
  void changeNumberOfPlots(int which);
  void comboBoxesEnable();

  void buildDefaultView();

  static int getCount(){ return plotLayoutWindow::count; };

  void viewModified(){ Emit("viewModified()"); };

  enum signals
  {
    kButton_Apply,
    kButton_Preview,
    kButton_AddAPlot,
    kButton_RemAPlot
  };

  ClassDef(plotLayoutWindow,0)    
};


#endif
