#ifndef _TABBEDINFOWINDOW_H
#define _TABBEDINFOWINDOW_H

//Root headers
#include <TRootEmbeddedCanvas.h>
#include <TGNumberEntry.h>
#include <TGStatusBar.h>
#include <TGPicture.h>
#include <TSystem.h>
#include <TGLabel.h>
#include <TGFrame.h>
#include <TCanvas.h>
#include <TTimer.h>
#include <TGMenu.h>
#include <TGTab.h>
#include <TH1.h>
//c headers
#include <vector>
//NJE Headers
#include "TomographyStructs.h"
//#include "TomographyStructDefaults.h"
#include "embeddedInfoCanvas.h"

class tabbedInfoWindow: public TGMainFrame 
{
  protected:

    //Vector for tabs
    std::vector< TGCompositeFrame*   > CompFrameVec;
    std::vector< embeddedInfoCanvas* > CanVec;

    //Widgets
    TGTab* InjTab;

  public:

    tabbedInfoWindow(const TGWindow *p, UInt_t w, UInt_t h );
    virtual ~tabbedInfoWindow();

    void raise(){ Emit("raise()"); };
    void wantsFocus(){ this->RequestFocus(); this->RaiseWindow(); };

    int getCurrentTab(){ return InjTab->GetCurrent(); };

    embeddedInfoCanvas* getCanvas(int tab){ return CanVec[tab]; };

    void setInfo( int tab, const char* text );
    void setTab(int id);
    void addTabFrame(int tabs);
    
  ClassDef( tabbedInfoWindow, 0 )    
};

#endif

