#ifndef _thumbWindow_H
#define _thumbWindow_H

#include <TRootEmbeddedCanvas.h>
#include <TGNumberEntry.h>
#include <TG3DLine.h>
#include <TGLabel.h>
#include <TGFrame.h>
#include <TCanvas.h>
#include <TGMenu.h>
#include <TGTab.h>
#include <TH1.h>

#include <vector>

#include "TomographyStructs.h"
//#include "TomographyStructDefaults.h"
#include "Global_Values_Extern.h"
#include "tabbedInfoWindow.h"
#include "masterController.h"
#include "dataController.h"
#include "mainView.h"

class dataController;
class masterController;
class tabbedInfoWindow;

class thumbWindow: public tabbedInfoWindow
{  
  private:
    static int count;

    masterController* master;

    TGNumberEntry *BegBox;
    TGNumberEntry *EndBox; 
    TGNumberEntry *RowBox;

    int begBunch;
    int endBunch;
    int rowWidth;

    TGMenuBar *fMenuBar;
    
    std::vector<plotFormat> *mainPlotFormat;

    int whatToPlot;

  public:

    thumbWindow( const TGWindow *p, UInt_t h, UInt_t w, masterController* masterControl, std::vector<plotFormat>* pf, UInt_t options = kHorizontalFrame );
    virtual ~thumbWindow();

    void CloseWindow();
    
    int getPlotOption();
    int getStartBox();
    int getEndBox();
    int getPerRowBox();

    void setPlotOption(Int_t id);

    void createUserView();
    void viewModified(){ Emit("viewModified()"); };

    static int getCount(){ return thumbWindow::count; };
    void emitPad(int tab, TVirtualPad* pad){ EmitVA( "emitPad(int,TVirtualPad*)", 2, tab, pad ); };
    void emitButton( Int_t which ){ EmitVA( "emitButton(Int_t)", 1, which ); };

    enum windowSignals
    {
        kButton_Update,

        kMenu_File_Save_Canvas_PDF,

        kMenu_Opts_Recon,          
        kMenu_Opts_Recon_Data,     
        kMenu_Opts_Recon_Prof_Data   
    };

    ClassDef(thumbWindow,0);    
};


#endif
